#ifndef POINT_H_INCLUDED
#define POINT_H_INCLUDED

#include "bmp.h"
#include <cstring>
#define PI 3.1415926535897932384626

class point
{

private:
    SHORT m_x;
    SHORT m_y;
    ULONG m_couleur;

public:
    point(void);
    point(SHORT x, SHORT y, ULONG couleur);
    point(point& copiePoint);
    void geoTranslation(SHORT x);
    void geoTranslation(SHORT x, SHORT y);
    void geoHomothetie(point& centre, float k);
    void geoRotation(point& centre, double degree);
    void geoRotation(point& centre, double degree, bool isTrig);
    void afficher(Bmp& imageTemp);
    SHORT getCoordX(void);
    SHORT getCoordY(void);
    ULONG getColor(void);
    point getPoint(void);
    void redefine(short x, short y, ULONG color);
    bool operator!=(const point& b) const;

};

#endif // POINT_H_INCLUDED
