#include "segment.h"

segment :: segment(void):m_pointA(0,0,VERT),m_pointB(0,0,VERT)
{}

segment :: segment(point paramA, point paramB):m_pointA(paramA),m_pointB(paramB)
{}

segment :: segment(segment& copie)
{
    m_pointA = copie.getPointA();
    m_pointB = copie.getPointB();
}

point segment :: getPointA(void)
{
    return m_pointA;
}

point segment :: getPointB(void)
{
    return m_pointB;
}

void segment :: rotateSegment(double rotation)
{
    m_pointA.geoRotation(m_pointB,rotation);
}

void segment :: homothetieSegment(float k)
{
    m_pointA.geoHomothetie(m_pointB,k);
}

void segment :: translationSegment(SHORT x, SHORT y)
{
    m_pointA.geoTranslation(x,y);
}

void segment :: afficher(Bmp& imageTemp)
{
    imageTemp.line(m_pointA.getCoordX(),m_pointA.getCoordY(),m_pointB.getCoordX(),m_pointB.getCoordY(),m_pointA.getColor());
}
